# -*- coding: utf-8 -*-
class SimpleApp
  def call(env)
    return [200, {'Content-Type' => 'text/plain'}, ["ruby, ruby, ruby"]]
  end
end
class RubyEmphasizer
  def initialize(app)
    @app = app
  end

  def call(env)
    code, headers, body = *@app.call(env)
    body.map!{|text| text.gsub /ruby/i, '**RUBY**' }
    return [code, headers, body]
  end
end
use RubyEmphasizer
run SimpleApp.new
# 以下と同様の意味になる
# run RubyEmphasizer.new(SimpleApp.new)
